SbCylinderPlaneProjector(3)

NAME
SbCylinderPlaneProjector - The SbCylinderPlaneProjector class projects 2D points to a half-cylinder and a plane.

SYNOPSIS

#include <Inventor/projectors/SbCylinderPlaneProjector.h>

Inherits SbCylinderSectionProjector.

  Public Member Functions
SbCylinderPlaneProjector (const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
SbCylinderPlaneProjector (const SbCylinder &cyl, const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
virtual SbProjector * copy (void) const
virtual SbVec3f project (const SbVec2f &point)
virtual SbRotation getRotation (const SbVec3f &point1, const SbVec3f &point2)
Public Member Functions inherited from SbCylinderSectionProjector
SbCylinderSectionProjector (const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
SbCylinderSectionProjector (const SbCylinder &cyl, const float edgetol=0.9f, const SbBool orienttoeye=TRUE)
void setTolerance (const float edgetol)
float getTolerance (void) const
SbBool isWithinTolerance (const SbVec3f &point)
Public Member Functions inherited from SbCylinderProjector
SbVec3f projectAndGetRotation (const SbVec2f &point, SbRotation &rot)
void setCylinder (const SbCylinder &cyl)
const SbCylinder & getCylinder (void) const
void setOrientToEye (const SbBool orienttoeye)
SbBool isOrientToEye (void) const
void setFront (const SbBool infront)
SbBool isFront (void) const
SbBool isPointInFront (const SbVec3f &point) const
virtual void setWorkingSpace (const SbMatrix &space)
Public Member Functions inherited from SbProjector
virtual void setViewVolume (const SbViewVolume &vol)
const SbViewVolume & getViewVolume (void) const
const SbMatrix & getWorkingSpace (void) const
virtual SbBool tryProject (const SbVec2f &point, const float epsilon, SbVec3f &result)

  Protected Member Functions
SbRotation getRotation (const SbVec3f &point1, const SbBool tol1, const SbVec3f &point2, const SbBool tol2)
Protected Member Functions inherited from SbCylinderSectionProjector
virtual void setupTolerance (void)
Protected Member Functions inherited from SbCylinderProjector
SbCylinderProjector (const SbBool orienttoeye)
SbCylinderProjector (const SbCylinder &cylinder, const SbBool orienttoeye)
SbBool intersectCylinderFront (const SbLine &line, SbVec3f &result)
Protected Member Functions inherited from SbProjector
SbProjector (void)
virtual ~SbProjector ()
SbLine getWorkingLine (const SbVec2f &point) const
float findVanishingDistance (void) const
SbBool verifyProjection (const SbVec3f &projpt) const

  Additional Inherited Members
Protected Attributes inherited from SbCylinderSectionProjector
float tolerance
float tolDist
SbVec3f planeDir
SbLine planeLine
float planeDist
SbPlane tolPlane
Protected Attributes inherited from SbCylinderProjector
SbBool intersectFront
SbCylinder cylinder
SbBool orientToEye
SbBool needSetup
SbVec3f lastPoint
Protected Attributes inherited from SbProjector
SbViewVolume viewVol
SbMatrix worldToWorking
SbMatrix workingToWorld

Detailed Description

The SbCylinderPlaneProjector class projects 2D points to a half-cylinder and a plane. This projector uses a plane along with the half-cylinder of SbCylinderSectionProjector for projections. If the 2D point mapping "misses" the cylinder section, the 3D point will be projected onto the plane.

See also
    SbSpherePlaneProjector

Constructor & Destructor Documentation

  SbCylinderPlaneProjector::SbCylinderPlaneProjector (const float edgetol = 0.9f, const SbBool orienttoeye = TRUE)
Default constructor. See SbCylinderSectionProjector::SbCylinderSectionProjector().

  SbCylinderPlaneProjector::SbCylinderPlaneProjector (const SbCylinder & cyl, const float edgetol = 0.9f, const SbBool orienttoeye = TRUE)
Constructor with explicit specification of projection cylinder.

Member Function Documentation

  SbProjector * SbCylinderPlaneProjector::copy (void ) const [virtual]
Construct and return a copy of this projector. The caller is responsible for destructing the new instance.

Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable are using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes.

Reimplemented from SbCylinderSectionProjector.

  SbVec3f SbCylinderPlaneProjector::project (const SbVec2f & point) [virtual]
Project the 2D point from normalized viewport coordinates to a 3D point. The mapping will be done in accordance with the type of the projector.

Reimplemented from SbCylinderSectionProjector.

  SbRotation SbCylinderPlaneProjector::getRotation (const SbVec3f & point1, const SbVec3f & point2) [virtual]
Returns rotation on the projection surface which reorients point1 to point2.

Reimplemented from SbCylinderSectionProjector.

  SbRotation SbCylinderPlaneProjector::getRotation (const SbVec3f & point1, const SbBool tol1, const SbVec3f & point2, const SbBool tol2) [protected]
Calculates rotation from point1 to point2, with tol1 and tol2 deciding whether or not to use the tolerance setting.

Author

Generated automatically by Doxygen for Coin from the source code.